!!ARBfp1.0

#ambient light pass
#Author: Rich Whitehouse
#---------------------------------------------------------------------

#texture0 is the decal

OUTPUT	out = result.color;
TEMP	dcal, nrml, temp, cbrf;
PARAM	lightColor = program.env[1];
PARAM	objColor = program.env[2];
PARAM	mulf = {2.0, 2.0, 2.0};
PARAM	subf = {-1.0, -1.0, -1.0};

#fetch the textures
TEX	dcal, fragment.texcoord[0], texture[0], 2D;
TEX	nrml, fragment.texcoord[0], texture[1], 2D;

MAD	nrml, nrml, mulf, subf;
#re-normalize interpolated normal
DP3	temp, nrml, nrml;
RSQ	temp, temp.x;
MUL	nrml, nrml, temp;

#re-normalize interpolated light vector
DP3	temp, fragment.texcoord[1], fragment.texcoord[1];
RSQ	temp, temp.x;
MUL	temp, temp.x, fragment.texcoord[1];

DP3	temp.x, nrml, temp;
MAD	temp.x, temp.x, 0.5, 0.5;
MOV	temp.y, 0.5;

#look into the gradient map
TEX	temp, temp, texture[2], 2D;

MUL	temp, dcal, temp;
MUL	temp, fragment.color, temp; #factor in ambient color
MUL	temp, lightColor, temp;
MUL	temp, objColor, temp; #object color
#MUL	temp, 0.25, temp;
MOV	temp.a, dcal.a; #set alpha component by decal

MOV	out, temp;

END
